package com.hcloud.microservice.org;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.feign.EnableFeignClients;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.transaction.annotation.EnableTransactionManagement;


/**
 * @author xiezt
 */
@EnableDiscoveryClient
@EnableFeignClients(basePackages = {"com.hcloud.microservice.org.facade.client"})
@EnableTransactionManagement
@ComponentScan(basePackages = "com.hcloud")
@MapperScan(basePackages = {"com.hcloud.microservice.org.dao"})
@SpringBootApplication
public class OrgManageServiceApplication {
    public static void main(String[] args) {
        SpringApplication.run(OrgManageServiceApplication.class, args);
    }
}

