package com.hcloud.microservice.org.controller;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.annotation.AuthOrgValidate;
import com.hcloud.microserver.commoncore.annotation.AuthValidate;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microservice.org.facade.client.AuthManagerService;
import com.hcloud.microservice.org.facade.entity.BaseAuthorization;
import com.hcloud.microservice.org.facade.forms.BaseAuthForm;
import com.hcloud.microservice.org.service.BaseAuthorizationService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author xiezt
 */
@RestController
@RequestMapping("/auth")
@Slf4j
public class AuthManagerController extends BaseController implements AuthManagerService {

    @Autowired
    private BaseAuthorizationService baseAuthorizationService;

    @Override
    @PostMapping(value = "/searchAuthInfoByPage")
    @AuthOrgValidate
    public ResultVO<BaseAuthForm> searchAuthInfoByPage(@RequestBody BaseAuthForm baseAuthForm) {
        PageInfo pageInfo = baseAuthorizationService.searchBaseAuthInfoByPage(baseAuthForm);
        return success(pageInfo.getList(),pageInfo.getTotal());
    }

    @Override
    @AuthOrgValidate
    @PostMapping(value = "/addAuthInfo")
    public ResultVO addAuthInfo(@RequestBody BaseAuthForm baseAuthForm) {
        BaseAuthorization authorization = new BaseAuthorization();
        BeanUtils.copyProperties(baseAuthForm,authorization);
        int i = baseAuthorizationService.saveSelective(authorization);
        if(i==0){
            return new ResultVO<>(ResultEnum.SYS_ERROR);
        }
        return success();
    }

    @Override
    @AuthOrgValidate
    @PostMapping(value = "/updateAuthInfo")
    public ResultVO updateAuthInfo( @RequestBody BaseAuthForm baseAuthForm) {
        BaseAuthorization authorization = new BaseAuthorization();
        BeanUtils.copyProperties(baseAuthForm,authorization);
        int i = baseAuthorizationService.modifyByPrimaryKeySelective(authorization);
        if(i==0){
            return new ResultVO<>(ResultEnum.SYS_ERROR);
        }
        return success();
    }
}
