package com.hcloud.microservice.org.controller;

import com.hcloud.microserver.commoncore.annotation.AuthOrgValidate;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microservice.org.facade.client.PositionManagerService;
import com.hcloud.microservice.org.facade.forms.BasePositionForm;
import com.hcloud.microservice.org.service.BasePositionService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author JYJ
 */
@RestController
@RequestMapping("/position")
public class PositionManagerController extends BaseController implements PositionManagerService {


    @Autowired
    private BasePositionService basePositionService;

    /**
     * 通过父码查询子区域信息
     *
     * @param parentCode
     * @return
     */
    @GetMapping("/getByParentCode")
    @AuthOrgValidate
    @Override
    public ResultVO getBasePositionByParentCode(@RequestParam("parentCode") String parentCode) {
        List<BasePositionForm> resultList =  basePositionService.getBasePositionByParentCode(parentCode);
        return success(resultList);
    }

    /**
     * 通过编码码查询子区域信息
     *
     * @param code
     * @return
     */
    @GetMapping("/getByCode")
    @AuthOrgValidate
    @Override
    public ResultVO getBasePositionByCode(@RequestParam("code")  String code) {
        BasePositionForm basePositionForm =  basePositionService.getBasePositionByCode(code);
        return success(basePositionForm);
    }
}
