package com.hcloud.microservice.org.dao;


import com.github.pagehelper.Page;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microservice.org.bo.BaseAuthBO;
import com.hcloud.microservice.org.facade.entity.BaseAuthorization;
import com.hcloud.microservice.org.facade.forms.BaseAuthForm;

import java.util.List;

public interface BaseAuthorizationMapper extends BaseMapper<BaseAuthorization,String> {

    /**
     *分页查询权限信息
     *
     * @param pageBean 分页信息
     * @return 权限分页信息
     */
    Page<BaseAuthBO> searchBaseAuthInfoByPage(PageBean<BaseAuthForm> pageBean);

    /**
     * 查询菜单权限信息（存在url地址的权限）
     * @return
     */
    List<BaseAuthBO> searchMenuAuthInfo();


    /**
     * 查询所有权限信息
     * @return
     */
    Page<BaseAuthBO> searchAllBaseAuthInfo();

}