package com.hcloud.microservice.org.dao;


import com.github.pagehelper.Page;
import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microservice.org.bo.BaseOrgAuthBO;
import com.hcloud.microservice.org.facade.entity.BaseOrgAuthorization;
import com.hcloud.microservice.org.facade.forms.BaseOrgAuthForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface BaseOrgAuthorizationMapper extends BaseMapper<BaseOrgAuthorization,String> {

    /**
     * 批量插入机构权限信息
     * @param list
     * @return
     */
    int batchOrgAuthInfo(List<BaseOrgAuthForm> list);


    /**
     * 通过机构id查询机构权限
     * @param pageBean
     * @return
     */
    List<BaseOrgAuthBO> searchOrgAuthInfoByOrgId(PageBean<BaseOrgAuthForm> pageBean);

    /**
     * 通过机构Id删除机构权限
     * @param orgGuid
     * @return
     */
    int delOrgAuthInfoByOrgId(@Param("id") String orgGuid);

    /**
     * 查询机构权限的功能权限guid
     * @param orgGuid
     * @return
     */
    List<String> searchOrgAuthStringByOrgId(@Param("id") String orgGuid);


    /**
     * 查询机构权限菜单
     * @return
     */
    List<BaseOrgAuthBO> searchOrgMenuInfo();


    /**
     * 查询机构权限信息
     * @param orgGuid
     * @return
     */
    List<BaseOrgAuthBO> searchAllOrgAuthInfo(@Param("id") String orgGuid);

}