package com.hcloud.microservice.org.dao;


import com.github.pagehelper.Page;
import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microservice.org.facade.entity.BaseRoleAuthorization;
import com.hcloud.microservice.org.facade.forms.BaseRoleAuthForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author xiezt
 */
public interface BaseRoleAuthorizationMapper extends BaseMapper<BaseRoleAuthorization,String> {
    /**
     * 批量插入角色权限信息
     * @param formsList
     * @return
     */
    int batchSaveRoleAuthInfo(List<BaseRoleAuthForm> formsList);


    /**
     * 通过角色Id查询角色权限信息
     * @param roleId
     * @param orgGuid
     * @return
     */
    List<String> searchRoleAuthByRoleId(@Param("roleId") String roleId, @Param("orgGuid") String orgGuid);

    /**
     * 删除角色权限信息通过角色ID
     * @param roleId
     * @param orgGuid
     * @return
     */
    int delRoleAuthByRoleId(@Param("id") String roleId,@Param("orgGuid") String orgGuid);
}