package com.hcloud.microservice.org.dao;


import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microservice.org.facade.entity.BaseUserAuthorization;
import com.hcloud.microservice.org.facade.forms.BaseUserAuthForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface BaseUserAuthorizationMapper extends BaseMapper<BaseUserAuthorization,String> {

    /**
     * 批量插入用户权限信息
     * @param list
     * @return
     */
    int batchSaveUserAuthInfo(List<BaseUserAuthForm> list);

    /**
     * 删除用户权限通过用户Id
     * @param userId 用户id
     * @param orgGuid 机构id
     * @return
     */
    int delUserAuthInfoByUserId(@Param("id") String userId,@Param("oguid") String orgGuid);


    /**
     * 通过用户Id查询用户权限
     * @param userId 用户id
     * @param orgGuid 机构id
     * @return
     */
    List<String> searchUserAuthInfoByUserId(@Param("id") String userId,@Param("oguid") String orgGuid);

    
}