package com.hcloud.microservice.org.service;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microservice.org.bo.BaseAuthBO;
import com.hcloud.microservice.org.facade.entity.BaseAuthorization;
import com.hcloud.microservice.org.facade.forms.BaseAuthForm;

import java.util.List;

/**
 * 权限服务类
 * @author xiezt
 */
public interface BaseAuthorizationService extends BaseServie<BaseAuthorization,String> {

        /**
         *分页查询权限信息
         *
         * @param baseAuthForm 页面交互信息
         * @return 权限分页信息
         */
        PageInfo searchBaseAuthInfoByPage(BaseAuthForm baseAuthForm);

        /**
         * 查询菜单权限信息（存在url地址的权限）
         * @return
         */
        List<BaseAuthBO> searchMenuAuthInfo();
}
