package com.hcloud.microservice.org.service;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microservice.org.bo.BaseOrgAuthBO;
import com.hcloud.microservice.org.facade.entity.BaseOrgAuthorization;
import com.hcloud.microservice.org.facade.forms.BaseOrgAuthForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author xiezt
 */
public interface BaseOrgAuthorizationService extends BaseServie<BaseOrgAuthorization,String> {

    /**
     * 批量插入机构权限信息
     * @param listForm
     * @param orgGuid
     * @return
     */
    int batchOrgAuthInfo(List<BaseOrgAuthForm> listForm,String orgGuid);


    /**
     * 通过机构id查询机构权限
     * @param baseOrgAuthForm
     * @return
     */
    PageInfo searchOrgAuthInfoByOrgId(BaseOrgAuthForm baseOrgAuthForm);



    /**
     * 为机构权限分配查询机构所有权限
     * @param orgGuid
     * @return
     */
    List<BaseOrgAuthBO> searchAllOrgAuthInfoForOrg(String orgGuid);
}
