package com.hcloud.microservice.org.service;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microservice.org.bo.BaseRoleAuthBO;
import com.hcloud.microservice.org.bo.BaseRoleUserBO;
import com.hcloud.microservice.org.facade.forms.BaseRoleAuthForm;
import com.hcloud.microservice.org.facade.entity.BaseRole;
import com.hcloud.microservice.org.facade.forms.BaseRoleForm;

import java.util.List;


/**
 * @author xiezt
 */
public interface BaseRoleService extends BaseServie<BaseRole,String> {


    /**
     * 分页查询角色信息
     * @param baseRoleForm
     * @return
     */
    PageInfo searchRoleInfoByPage(BaseRoleForm baseRoleForm);



    /**
     * 批量插入角色权限信息
     * @param formsList
     * @param roleId
     * @return
     */
    int batchSaveRoleAuthInfo(List<BaseRoleAuthForm> formsList,String roleId,String orgGuid);


    /**
     * 通过角色Id删除角色权限信息
     * @param roleId
     * @param orgGuid
     * @return
     */
    int delRoleAuthInfoByRoleId(String roleId, String orgGuid);

    /**
     * 查询角色机构权限信息
     * @param roleId
     * @param orgGuid
     * @return
     */
    List<BaseRoleAuthForm> searchRoleAuthInfo(String roleId, String orgGuid);

    /**
     * 查询角色机构信息(不与机构权限信息比对)
     * @param roleId
     * @param orgGuid
     * @return
     */
    List<BaseRoleAuthForm> searchOnlyRoleAuthInfo(String roleId, String orgGuid);

}
