package com.hcloud.microservice.org.service.impl;

import com.github.pagehelper.Page;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microserver.commoncore.util.GetUUID;
import com.hcloud.microservice.org.bo.BaseOrgAuthBO;
import com.hcloud.microservice.org.dao.BaseOrgAuthorizationMapper;
import com.hcloud.microservice.org.facade.entity.BaseOrgAuthorization;
import com.hcloud.microservice.org.facade.forms.BaseOrgAuthForm;
import com.hcloud.microservice.org.service.BaseOrgAuthorizationService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Service("baseOrgAuthorizationService")
public class BaseOrgAuthorizationServiceImpl implements BaseOrgAuthorizationService {

    @Resource
    private BaseOrgAuthorizationMapper baseOrgAuthorizationMapper;

    @Override
    public int delByPrimaryKey(String guid) {
        return baseOrgAuthorizationMapper.deleteByPrimaryKey(guid);
    }

    @Override
    public int save(BaseOrgAuthorization record) {
        record.setGuid(GetUUID.getUUID());
        return baseOrgAuthorizationMapper.insert(record);
    }

    @Override
    public int saveSelective(BaseOrgAuthorization record) {
        return baseOrgAuthorizationMapper.insertSelective(record);
    }

    @Override
    public BaseOrgAuthorization queryByPrimaryKey(String guid) {
        return baseOrgAuthorizationMapper.selectByPrimaryKey(guid);
    }

    @Override
    public int modifyByPrimaryKeySelective(BaseOrgAuthorization record) {
        return baseOrgAuthorizationMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public int modifyByPrimaryKeyWithBLOBs(BaseOrgAuthorization record) {
        return 0;
    }

    @Override
    public int modifyByPrimaryKey(BaseOrgAuthorization record) {
        return baseOrgAuthorizationMapper.updateByPrimaryKey(record);
    }

    /**
     * 批量插入机构权限信息
     *
     * @param listForm
     * @return
     */
    @Override
    public int batchOrgAuthInfo(List<BaseOrgAuthForm> listForm,String orgGuid) {
        if(listForm.size()>0){
            baseOrgAuthorizationMapper.delOrgAuthInfoByOrgId(orgGuid);
        }
        return baseOrgAuthorizationMapper.batchOrgAuthInfo(listForm);
    }

    /**
     * 通过机构id查询机构权限
     *
     * @param baseOrgAuthForm
     * @return
     */
    @Override
    public PageInfo searchOrgAuthInfoByOrgId(BaseOrgAuthForm baseOrgAuthForm) {
        PageBean pageBean = new PageBean(baseOrgAuthForm);
        PageHelper.startPage(baseOrgAuthForm.getPageNo(),baseOrgAuthForm.getPageSize());
        List<BaseOrgAuthBO> page = baseOrgAuthorizationMapper.searchOrgAuthInfoByOrgId(pageBean);
        return new PageInfo(page);
    }

    /**
     * 为机构权限分配查询机构所有权限
     *
     * @param orgGuid
     * @return
     */
    @Override
    public List<BaseOrgAuthBO> searchAllOrgAuthInfoForOrg(String orgGuid) {
        BaseOrgAuthForm baseOrgAuthForm = new BaseOrgAuthForm();
        baseOrgAuthForm.setFkOrgGuid(orgGuid);
        return baseOrgAuthorizationMapper.searchOrgAuthInfoByOrgId(new PageBean(baseOrgAuthForm));
    }
}
