package com.hcloud.microservice.org.service.impl;

import com.google.common.collect.Lists;
import com.hcloud.microserver.commoncore.util.BeanCopyUtil;
import com.hcloud.microservice.org.dao.BasePositionMapper;
import com.hcloud.microservice.org.facade.entity.BasePosition;
import com.hcloud.microservice.org.facade.forms.BasePositionForm;
import com.hcloud.microservice.org.service.BasePositionService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

/**
 * @author xiezt
 */
@Slf4j
@Service("basePositionService")
public class BasePositionServiceImpl implements BasePositionService {


    @Resource
    private BasePositionMapper basePositionMapper;

    /**
     * 通过编码查询区域信息
     *
     * @param code
     * @return
     */
    @Override
    public BasePositionForm getBasePositionByCode(String code) {
        BasePositionForm basePositionForm = new BasePositionForm();
        BasePosition basePosition = basePositionMapper.getBasePositionByCode(code);
        if(null!= basePosition){
            BeanCopyUtil.copyBean(basePosition,basePosition);
        }
        return basePositionForm;
    }

    /**
     * 通过父编码查询区域信息
     *
     * @param parentCode
     * @return
     */
    @Override
    public List<BasePositionForm> getBasePositionByParentCode(String parentCode) {
        List<BasePositionForm> resultList = Lists.newArrayList();
        List<BasePosition> basePositionList = basePositionMapper.getBasePositionByParentCode(parentCode);
        if(null!= basePositionList && basePositionList.size()>0){
            resultList = BeanCopyUtil.convertList(basePositionList,BasePositionForm.class);
        }
        return resultList;
    }

    @Override
    public int delByPrimaryKey(Integer guid) {
        return 0;
    }

    @Override
    public int save(BasePosition record) {
        return 0;
    }

    @Override
    public int saveSelective(BasePosition record) {
        return 0;
    }

    @Override
    public BasePosition queryByPrimaryKey(Integer guid) {
        return null;
    }

    @Override
    public int modifyByPrimaryKeySelective(BasePosition record) {
        return 0;
    }

    @Override
    public int modifyByPrimaryKeyWithBLOBs(BasePosition record) {
        return 0;
    }

    @Override
    public int modifyByPrimaryKey(BasePosition record) {
        return 0;
    }
}
