package com.hcloud.microservice.org.controller;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microservice.org.facade.forms.BaseAuthForm;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.http.MediaType;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.MvcResult;

import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.post;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.content;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

@Slf4j
@RunWith(SpringRunner.class)
@SpringBootTest
@AutoConfigureMockMvc
public class AuthManagerControllerTest {

    @Autowired
    private MockMvc mockMvc;

    @Test
    public void searchAuthInfoByPage() throws Exception {
        BaseAuthForm baseAuthForm = new BaseAuthForm();
        baseAuthForm.setFunName("权限");
            MvcResult mvcResult =  mockMvc.perform(post("/auth/searchAuthInfoByPage").
                    contentType(MediaType.APPLICATION_JSON_UTF8).
                    content(JSONObject.toJSONString(baseAuthForm))).andExpect(status().isOk()).
                    andExpect(content().contentType(MediaType.APPLICATION_JSON_UTF8)).andReturn();
            log.info("========================>{}",mvcResult.getResponse().getContentAsString());
    }

    @Test
    public void addAuthInfo() {
    }

    @Test
    public void updateAuthInfo() {
    }
}