package com.hcloud.microservice.org.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.hcloud.microservice.org.TestInit;
import com.hcloud.microservice.org.facade.forms.BaseUserForm;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.autoconfigure.web.servlet.AutoConfigureMockMvc;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.http.MediaType;
import org.springframework.test.context.junit4.SpringRunner;
import org.springframework.test.web.servlet.MockMvc;
import org.springframework.test.web.servlet.MvcResult;

import java.util.Date;

import static org.junit.Assert.*;
import static org.springframework.test.web.servlet.request.MockMvcRequestBuilders.post;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.content;
import static org.springframework.test.web.servlet.result.MockMvcResultMatchers.status;

@Slf4j
@RunWith(SpringRunner.class)
@SpringBootTest
@AutoConfigureMockMvc
public class UserManagerControllerTest extends TestInit {

    @Autowired
    private MockMvc mockMvc;

    @Test
    public void searchUserInfoByPage() {
    }

    @Test
    public void addUserInfo() throws Exception {
        BaseUserForm user = new BaseUserForm();
        user.setAccount("admin");
        user.setUserName("超级管理员");
        user.setDicSexCode(1);
        user.setPasswd("123456");
        user.setIsForbid(0);
        user.setRemark("测试类生成用户信息");
        user.setState(1);
        user.setCreateUser(super.FK_CREATE_USER);
        user.setCreateTime(new Date());
        user.setModifiedUser(super.FK_MODIFIED_USER);
        user.setModifiedTime(new Date());
        user.setFkProductGuid(super.FK_PRODUCT_GUID);
        user.setFkOrgGuid(super.FK_ORG_GUID);
        MvcResult result = mockMvc.perform(post("/user/addUserInfo").
                contentType(MediaType.APPLICATION_JSON_UTF8).
                content(JSONObject.toJSONString(user))).
                andExpect(content().contentType(MediaType.APPLICATION_JSON_UTF8)).
                andExpect(status().isOk()).andReturn();
        log.info("json===================>{}", result.getResponse().getContentAsString());
    }

    @Test
    public void updateUserInfo() {
    }

    @Test
    public void searchUserAuthInfo() {
    }

    @Test
    public void distributionUserAuthInfo() {
    }

    @Test
    public void loginSystem() throws Exception {
        String account = "admin";
        String password = "123456";
        MvcResult result = mockMvc.perform(post("/user/addUserInfo").
                contentType(MediaType.TEXT_HTML_VALUE).
                param("account", account).
                param("password", password)).andReturn();
        log.info("result=========================>{}", result.getResponse().getStatus());
        log.info("result=========================>{}", result.getResponse().getContentAsString());
    }

    @Test
    public void getUserMenusInfo() {
    }

    @Test
    public void getSubUserAuthInfo() {
    }
}