package com.hcloud.microservice.org.service.impl;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.util.GetUUID;
import com.hcloud.microservice.org.TestInit;
import com.hcloud.microservice.org.facade.entity.BaseOrgAuthorization;
import com.hcloud.microservice.org.facade.forms.BaseOrgAuthForm;
import com.hcloud.microservice.org.service.BaseOrgAuthorizationService;
import lombok.extern.slf4j.Slf4j;
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import static org.junit.Assert.*;

@Slf4j
@RunWith(SpringRunner.class)
@SpringBootTest
//@Transactional
public class BaseOrgAuthorizationServiceImplTest extends TestInit {

    @Autowired
    private BaseOrgAuthorizationService baseOrgAuthorizationService;

    @Before
    public void setUp() throws Exception {
    }

    @After
    public void tearDown() throws Exception {
    }

    @Test
    public void saveSelective() {
        BaseOrgAuthorization bean = new BaseOrgAuthorization();
        bean.setGuid(GetUUID.getUUID());
        bean.setFkProductGuid(super.FK_PRODUCT_GUID);
        bean.setFkOrgGuid(super.FK_ORG_GUID);
        bean.setParentGuid(GetUUID.getUUID());
        bean.setFkAuthGuid(GetUUID.getUUID());
        bean.setFunName("溯源系统管理");
        bean.setAuthStr("sys:org:index");
        bean.setRemark("溯源系统管理");
        bean.setOrderby(99);
        bean.setIsForbid(0);
        bean.setState(1);
        bean.setCreateUser(super.FK_CREATE_USER);
        bean.setCreateTime(new Date());
        bean.setModifiedUser(super.FK_MODIFIED_USER);
        bean.setModifiedTime(new Date());
        bean.setNodeType(0);
        int i= baseOrgAuthorizationService.saveSelective(bean);
        Assert.assertEquals(i,1);
    }

    @Test
    public void queryByPrimaryKey() {
    }

    @Test
    public void modifyByPrimaryKeySelective() {
    }

    @Test
    public void batchOrgAuthInfo() {
        Page<BaseOrgAuthForm> list = new Page<>();
        for (int i = 0; i <20 ; i++) {
            BaseOrgAuthForm bean = new BaseOrgAuthForm();
            bean.setId(GetUUID.getUUID());
            bean.setFkProductGuid(super.FK_PRODUCT_GUID);
            bean.setFkOrgGuid(super.FK_ORG_GUID);
            bean.setParentGuid(GetUUID.getUUID());
            bean.setFkAuthGuid(GetUUID.getUUID());
            bean.setFunName("溯源系统管理");
            bean.setAuthStr("sys:org:index");
            bean.setFileUrl("");
            bean.setIco("");
            bean.setRemark("溯源系统管理");
            bean.setOrderby(99);
            bean.setIsForbid(0);
            bean.setState(1);
            bean.setCreateUser(super.FK_CREATE_USER);
            bean.setCreateTime(new Date());
            bean.setModifiedUser(super.FK_MODIFIED_USER);
            bean.setModifiedTime(new Date());
            bean.setNodeType(0);
            list.add(bean);
        }
        int i = baseOrgAuthorizationService.batchOrgAuthInfo(list,super.FK_ORG_GUID);
        Assert.assertEquals(i,20);
    }

    @Test
    public void searchOrgAuthInfoByOrgId() {
        BaseOrgAuthForm baseOrgAuthForm = new BaseOrgAuthForm();
        baseOrgAuthForm.setFkOrgGuid(super.FK_ORG_GUID);
        PageInfo pageInfo = baseOrgAuthorizationService.searchOrgAuthInfoByOrgId(baseOrgAuthForm);
        log.info("context=================>{}",pageInfo.getList().get(0));
        Assert.assertEquals(21,pageInfo.getTotal());
        Assert.assertEquals(10,pageInfo.getList().size());

    }
}