package com.hcloud.microservice.org.service.impl;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.util.GetUUID;
import com.hcloud.microservice.org.TestInit;
import com.hcloud.microservice.org.facade.entity.BaseOrg;
import com.hcloud.microservice.org.facade.forms.BaseOrgForm;
import com.hcloud.microservice.org.service.BaseOrgService;
import lombok.extern.slf4j.Slf4j;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.Date;

import static org.junit.Assert.*;

@Slf4j
@RunWith(SpringRunner.class)
@SpringBootTest
//@Transactional
public class BaseOrgServiceImplTest extends TestInit {

    @Autowired
    private BaseOrgService baseOrgService;

    @Test
    public void saveSelective() {
        BaseOrg baseOrg = new BaseOrg();
        baseOrg.setGuid(GetUUID.getUUID());
        baseOrg.setDicOrgTypeCode(1);
        baseOrg.setOrgName("xxxxx个人");
        baseOrg.setOrgCode("600160");
        baseOrg.setOrgBrevity("160");
        baseOrg.setIco("icon.ico");
        baseOrg.setOrgAddress("贵州省修文县xxxx乡xxxx村");
        baseOrg.setPositionType(3);
        baseOrg.setFkPositionId(GetUUID.getUUID());
        baseOrg.setPrincipals("王五");
        baseOrg.setTel("18799876543");
        baseOrg.setRemark("测试方法生成记录二");
        baseOrg.setQrcodeUrlPrefixe("https://www.xxxxx.com/600160");
        baseOrg.setState(1);
        baseOrg.setCreateUser(super.FK_CREATE_USER);
        baseOrg.setCreateTime(new Date());
        baseOrg.setModifyUser(super.FK_MODIFIED_USER);
        baseOrg.setModiedTime(new Date());
        int i = baseOrgService.saveSelective(baseOrg);
        Assert.assertEquals(1,i);
    }

    @Test
    public void queryByPrimaryKey() {
        String guid="7ea42e7a2bb94670951b9d0fcf82a1d8";
        BaseOrg baseOrg = baseOrgService.queryByPrimaryKey(guid);
        Assert.assertNotNull("查询到条件对象",baseOrg);
    }

    @Test
    public void modifyByPrimaryKeySelective() {
        BaseOrg baseOrg = new BaseOrg();
        baseOrg.setGuid("7ea42e7a2bb94670951b9d0fcf82a1d8");
        baseOrg.setPrincipals("李四");
        baseOrg.setTel("18799876578");
        baseOrg.setRemark("测试方法修改记录");
        baseOrg.setState(0);
        baseOrg.setModifyUser(super.FK_MODIFIED_USER);
        baseOrg.setModiedTime(new Date());
        int i = baseOrgService.modifyByPrimaryKeySelective(baseOrg);
        Assert.assertEquals(1,i);
        BaseOrg baseOrgs = baseOrgService.queryByPrimaryKey(baseOrg.getGuid());
        Assert.assertEquals("李四",baseOrgs.getPrincipals());
    }

    @Test
    public void searchOrgInfoByPage() {
        BaseOrgForm baseOrgForm = new BaseOrgForm();
//        baseOrgForm.setDicOrgTypeCode(1);
        baseOrgForm.setOrgName("xxxxx农企");
//        baseOrgForm.setOrgCode("600159");
//        baseOrgForm.setOrgAddress("贵州省贵阳市xxxx区xxxx村");
        baseOrgForm.setTel("18799876578");
        PageInfo pageInfo = baseOrgService.searchOrgInfoByPage(baseOrgForm);
        Assert.assertNotNull(pageInfo.getList());
        Assert.assertEquals(1,pageInfo.getTotal());
    }
}