package com.hcloud.microservice.org.service.impl;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.util.GetUUID;
import com.hcloud.microservice.org.TestInit;
import com.hcloud.microservice.org.facade.entity.BaseRole;
import com.hcloud.microservice.org.facade.forms.BaseRoleAuthForm;
import com.hcloud.microservice.org.facade.forms.BaseRoleForm;
import com.hcloud.microservice.org.service.BaseRoleService;
import lombok.extern.slf4j.Slf4j;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@Slf4j
@RunWith(SpringRunner.class)
@SpringBootTest
//@Transactional
public class BaseRoleServiceImplTest extends TestInit {

    @Autowired
    private BaseRoleService baseRoleService;

    @Test
    public void saveSelective() {
        BaseRole baseRole = new BaseRole();
        baseRole.setGuid(GetUUID.getUUID());
        baseRole.setFkOrgGuid(super.FK_ORG_GUID);
        baseRole.setFkProductGuid(super.FK_PRODUCT_GUID);
        baseRole.setRoleName("业务员");
        baseRole.setIsForbid(0);
        baseRole.setRemark("测试方法生成角色信息");
        baseRole.setState(1);
        baseRole.setCreateUser(super.FK_CREATE_USER);
        baseRole.setCreateTime(new Date());
        baseRole.setModifiedUser(super.FK_MODIFIED_USER);
        baseRole.setModifiedTime(new Date());
       int i = baseRoleService.saveSelective(baseRole);
        Assert.assertEquals(1,i);
    }

    @Test
    public void queryByPrimaryKey() {
        String guid = "8e1ccb4116454ebbbb5f0970422253b0";
        BaseRole role = baseRoleService.queryByPrimaryKey(guid);
        Assert.assertNotNull(role);
        Assert.assertEquals(guid,role.getGuid());
    }

    @Test
    public void modifyByPrimaryKeySelective() {
        String guid = "8e1ccb4116454ebbbb5f0970422253b0";
        BaseRole baseRole = new BaseRole();
        baseRole.setGuid(guid);
        baseRole.setFkOrgGuid(super.FK_ORG_GUID);
        baseRole.setFkProductGuid(super.FK_PRODUCT_GUID);
        baseRole.setRoleName("信息管理员");
        baseRole.setIsForbid(0);
        baseRole.setRemark("测试方法修改角色信息");
        baseRole.setState(0);
        baseRole.setModifiedUser(super.FK_MODIFIED_USER);
        baseRole.setModifiedTime(new Date());
        int i = baseRoleService.modifyByPrimaryKeySelective(baseRole);
        Assert.assertEquals(1,i);
    }

    @Test
    public void batchSaveRoleAuthInfo() {
        String guid = "8e1ccb4116454ebbbb5f0970422253b0";
        List<BaseRoleAuthForm> list = new ArrayList<>();
        for (int i = 0; i <20 ; i++) {
            BaseRoleAuthForm baseRoleAuthForm = new BaseRoleAuthForm();
            baseRoleAuthForm.setFkAuthGuid(GetUUID.getUUID());
            baseRoleAuthForm.setFkRoleGuid(guid);
            baseRoleAuthForm.setFkProductGuid(super.FK_PRODUCT_GUID);
            baseRoleAuthForm.setFkOrgGuid(super.FK_ORG_GUID);
            list.add(baseRoleAuthForm);
        }
        int i = baseRoleService.batchSaveRoleAuthInfo(list,guid,super.FK_ORG_GUID);
        Assert.assertEquals(20,i);
    }

    @Test
    public void searchRoleAuthByRoleId() {
        String guid = "8e1ccb4116454ebbbb5f0970422253b0";
        List<String> list = new ArrayList<>(); //baseRoleService.searchRoleAuthByRoleId(guid,super.FK_ORG_GUID);
//        Assert.assertNotNull(list);
//        Assert.assertEquals(20,list.size());
    }

    @Test
    public void delRoleAuthInfoByRoleId() {
        String guid = "8e1ccb4116454ebbbb5f0970422253b0";
        int i = baseRoleService.delRoleAuthInfoByRoleId(guid,super.FK_ORG_GUID);
        Assert.assertEquals(20,i);
    }

    @Test
    public void  searchRoleInfoByPage(){
        BaseRoleForm baseRoleForm = new BaseRoleForm();
        baseRoleForm.setRoleName("信息");
       PageInfo pageInfo =  baseRoleService.searchRoleInfoByPage(baseRoleForm);
       Assert.assertNotNull(pageInfo.getList());
       Assert.assertEquals(1,pageInfo.getTotal());
    }
}